% iA=InvertMatrix(A)
%
% Returns iA, the inverse of matrix A. So
%    A * iA = ID
%
% The difference of the different methods used here is its numerical stability.
% This is commented in the the article 'Moment-Preserving Image Approximation'
%
% All the funcionts in this directory use this function to invert matrixes
% when requiered. So just change this function and you will get the diffent
% results introduced in the paper. 
%
% The recomended method is the '\' operator
%
% Input parameters:
%       > A: (m,n) Matrix to be inverted.
% Output parameters:
%       > iA: The inverse matrix, with size (n,m)
%
% ---------------------------------------------------------------
function iA=InvertMatrix(A)
 
  [m,n]=size(A);
  if m~=n
    error('Non-squared matrix in InvertMatrix');
  end

  % Uncomment the method you want to use.

  % Naive method (only works for squared matrixes)
  iA=inv(A);  

  % Gaussian elimination based method (only works for squared matrixes)
 % iA=A \ eye(n);

  %The two Kaczmarz-based methods are not fully-tested
  
  % Kaczmarz Method (with relaxation parameters)
% iA=KaczmarzInvert(A)

  % Extended Kaczmarz Method (with relaxation parameters)
% iA=ExtendedKaczmarzInvert(A)
  
